;Notice : 	All branches and variables must be position-independent
;		Variables must be acessed via PC

		;for safety ;-)
		rts

		;Identify string !
		dc.b		'C2P',0
		
		;Main routine		
		;a0 - chunkybuffer
		;a1 - planes
Begin		dc.l		Chunky1x1-Begin		;offset to routine

		;Init routine
		;d0 - Width
		;d1 - Height
		;d2 - PlaneSize
		dc.l		InitChunky-Begin	;offset to routine

		dc.l		Support-Begin
		
width		equ	320		; must be multiple of 32
height		equ	200
plsiz		equ	(width/8)*256


merge	MACRO	in1,in2,tmp3,mask,shift
	move.l	\2,\3
	lsr.l	#\5,\3
	eor.l	\1,\3
	and.l	\4,\3
	eor.l	\3,\1
	
	IFEQ	\5-1
	add.l	\3,\3
	ELSE
	lsl.l	#\5,\3	\3 = b0r0
	ENDC

	eor.l	\3,\2
	ENDM
	
	
	
	
InitChunky	rts

	cnop	0,16

Chunky1x1

		; a0 = chunky buffer
		; a1 = output area
		
		move.l	a1,a4
		add.l	#4*plsiz,a1	; a1 -> plane4
		
			
		move.l	a0,a2
		add.l	#64000,a2

		lea	p0(pc),a3
		bra.s	mainloop

	cnop	0,16
mainloop:
	move.l	0(a0),d0
 	move.l	4(a0),d2
 	move.l	8(a0),d1
	move.l	12(a0),d3
	move.l	2(a0),d4
 	move.l	10(a0),d5
	move.l	6(a0),d6
	move.l	14(a0),d7

 	move.w	16(a0),d0
 	move.w	24(a0),d1
	move.w	20(a0),d2
	move.w	28(a0),d3
 	move.w	18(a0),d4
 	move.w	26(a0),d5
	move.w	22(a0),d6
	move.w	30(a0),d7
	
	adda.w	#32,a0
	move.l	d6,a5
	move.l	d7,a6

	merge	d0,d1,d6,#$00FF00FF,8
	merge	d2,d3,d6,#$00FF00FF,8

	merge	d0,d2,d6,#$0F0F0F0F,4	
	merge	d1,d3,d6,#$0F0F0F0F,4

	exg.l	d0,a5
	exg.l	d1,a6	
	
	merge	d4,d5,d6,#$00FF00FF,8
	merge	d0,d1,d6,#$00FF00FF,8
	
	merge	d4,d0,d6,#$0F0F0F0F,4
	merge	d5,d1,d6,#$0F0F0F0F,4

	merge	d2,d0,d6,#$33333333,2
	merge	d3,d1,d6,#$33333333,2	

	merge	d2,d3,d6,#$55555555,1
	merge	d0,d1,d6,#$55555555,1
	move.l	d3,2*4(a3)	;plane2
	move.l	d2,3*4(a3)	;plane3
	move.l	d1,0*4(a3)	;plane0
	move.l	d0,1*4(a3)	;plane1

	move.l	a5,d2
	move.l	a6,d3

	merge	d2,d4,d6,#$33333333,2
	merge	d3,d5,d6,#$33333333,2

	merge	d2,d3,d6,#$55555555,1
	merge	d4,d5,d6,#$55555555,1
	move.l	d3,6*4(a3)		;bitplane6
	move.l	d2,7*4(a3)		;bitplane7
	move.l	d5,4*4(a3)		;bitplane4
	move.l	d4,5*4(a3)		;bitplane5


inner:
	move.l	0(a0),d0
 	move.l	4(a0),d2
 	move.l	8(a0),d1
	move.l	12(a0),d3
	move.l	2(a0),d4
 	move.l	10(a0),d5
	move.l	6(a0),d6
	move.l	14(a0),d7

 	move.w	16(a0),d0
 	move.w	24(a0),d1
	move.w	20(a0),d2
	move.w	28(a0),d3
 	move.w	18(a0),d4
 	move.w	26(a0),d5
	move.w	22(a0),d6
	move.w	30(a0),d7
	
	adda.w	#32,a0
	move.l	d6,a5
	move.l	d7,a6

	; write	bitplane 7	

	move.l	2*4(a3),-2*plsiz(a1)	;plane2
	merge	d0,d1,d6,#$00FF00FF,8
	merge	d2,d3,d6,#$00FF00FF,8

	; write	
	move.l	3*4(a3),-plsiz(a1)	;plane3
	merge	d0,d2,d6,#$0F0F0F0F,4	
	merge	d1,d3,d6,#$0F0F0F0F,4

	exg.l	d0,a5
	exg.l	d1,a6	
	
	; write
	move.l	0*4(a3),(a4)+	;plane0
	merge	d4,d5,d6,#$00FF00FF,8
	merge	d0,d1,d6,#$00FF00FF,8
	
	; write	
	move.l	1*4(a3),-3*plsiz(a1) ;plane1
	merge	d4,d0,d6,#$0F0F0F0F,4
	merge	d5,d1,d6,#$0F0F0F0F,4

	; write	
	move.l	6*4(a3),2*plsiz(a1)	;bitplane6
	merge	d2,d0,d6,#$33333333,2
	merge	d3,d1,d6,#$33333333,2	

	; write
	move.l	7*4(a3),3*plsiz(a1)	;bitplane7
	merge	d2,d3,d6,#$55555555,1
	merge	d0,d1,d6,#$55555555,1
	move.l	d3,2*4(a3)	;plane2
	move.l	d2,3*4(a3)	;plane3
	move.l	d1,0*4(a3)	;plane0
	move.l	d0,1*4(a3)	;plane1

	move.l	a5,d2
	move.l	a6,d3

	move.l	4*4(a3),(a1)+		;bitplane4	
	merge	d2,d4,d6,#$33333333,2
	merge	d3,d5,d6,#$33333333,2

	move.l	5*4(a3),-4+1*plsiz(a1)	;bitplane5
	merge	d2,d3,d6,#$55555555,1
	merge	d4,d5,d6,#$55555555,1
	move.l	d3,6*4(a3)		;bitplane6
	move.l	d2,7*4(a3)		;bitplane7
	move.l	d5,4*4(a3)		;bitplane4
	move.l	d4,5*4(a3)		;bitplane5

	cmpa.l	a0,a2
	bne.w	inner

	move.l	2*4(a3),-2*plsiz(a1)	;plane2
	move.l	3*4(a3),-plsiz(a1)	;plane3
	move.l	0*4(a3),(a4)	;plane0
	move.l	1*4(a3),-3*plsiz(a1) 	;plane1
	move.l	6*4(a3),2*plsiz(a1)	;bitplane6
	move.l	7*4(a3),3*plsiz(a1)	;bitplane7
	move.l	4*4(a3),(a1)+		;bitplane4	
	move.l	5*4(a3),-4+1*plsiz(a1)	;bitplane5

	rts

	cnop	0,4

p0	dc.l	0
p1	dc.l	0
p2	dc.l	0
p3	dc.l	0
p4	dc.l	0
p5	dc.l	0
p6	dc.l	0
p7	dc.l	0

Support		dc.b	1
		dc.b	0
		dc.b	0
		dc.b	0
		dc.b	0
		